<?php
require_once("../../config/config_dir_raiz.php");
$config = new Config();
require_once($config->diretorio_raiz()."/src/model/bd/Bi_log_acessoDAO.php");
$bi_log_acessoDAO = new Bi_log_acessoDAO();
require_once($config->diretorio_raiz()."/src/model/bd/Bi_usuarioDAO.php");
$bi_usuarioDAO = new Bi_usuarioDAO(); 
require_once($config->diretorio_raiz()."/src/model/bd/Bi_analiseDAO.php");
$bi_analiseDAO = new Bi_analiseDAO(); 
require_once($config->diretorio_raiz()."/src/model/bd/Bi_paginaDAO.php");
$bi_paginaDAO = new Bi_paginaDAO(); 
$retorno = array();
if (isset($_GET["mod"]) && $_GET["mod"] == "form")
{
	if ( (isset($_GET["codigo"]) and $_GET["codigo"] != "")  )
	{
		$bi_log_acesso = $bi_log_acessoDAO->buscarBi_log_acesso($_GET["codigo"]);
	}else{
		$bi_log_acesso = new Bi_log_acesso();
		$bi_log_acesso->setUsuario(new Bi_usuario());
		$bi_log_acesso->setAnalise(new Bi_analise());
		$bi_log_acesso->setPagina(new Bi_pagina());
	}
	$listaUsuario = $bi_usuarioDAO->listarTodosRegistros(); 
	$listaAnalise = $bi_analiseDAO->listarTodosRegistros(); 
	$listaPagina = $bi_paginaDAO->listarTodosRegistros(); 
	if (isset($_GET["usuario"]) and $_GET["usuario"] != "")
	{
		$bi_log_acesso->setUsuario($bi_usuarioDAO->buscarBi_usuario($_GET["usuario"]));
		$campo_buscar = "&usuario=".$_GET["usuario"]; 
	}
	if (isset($_GET["analise"]) and $_GET["analise"] != "")
	{
		$bi_log_acesso->setAnalise($bi_analiseDAO->buscarBi_analise($_GET["analise"]));
		$campo_buscar = "&analise=".$_GET["analise"]; 
	}
	if (isset($_GET["pagina"]) and $_GET["pagina"] != "")
	{
		$bi_log_acesso->setPagina($bi_paginaDAO->buscarBi_pagina($_GET["pagina"]));
		$campo_buscar = "&pagina=".$_GET["pagina"]; 
	}
	include_once($config->diretorio_raiz()."/src/view/bi_log_acesso/Formulario.php");
}
elseif (isset($_GET["mod"]) && ($_GET["mod"] == "salvar" or $_GET["mod"] == "alterar"))
{
	$bi_log_acesso = new Bi_log_acesso();
	$bi_log_acesso->setCodigo($_POST['codigo']);
	$bi_log_acesso->setUsuario($_POST['usuario']);
	$bi_log_acesso->setAnalise($_POST['analise']);
	$bi_log_acesso->setPagina($_POST['pagina']);
	if ($_POST['data_acesso'] != "")
	{
		$dateData_acesso = DateTime::createFromFormat('d/m/Y H:i', $_POST['data_acesso']);
		$bi_log_acesso->setData_acesso($dateData_acesso);
	}
	$codigo = "";
	if ($_GET["mod"] == "alterar")
	{
		$bi_log_acesso->setCodigo($_POST['codigo']);
		$codigo = $bi_log_acesso->getCodigo();
		try
		{
			$retorno["mensagem"] = "Alterado com sucesso!";
			$retorno["status"] = true;
			$bi_log_acessoDAO->atualizar($bi_log_acesso);
		}
		catch (Exception  $e)
		{
			$retorno["mensagem"] = $e->getMessage();
			$retorno["status"] = false;
		}
	}
	else
	{
		try
		{
			$retorno["mensagem"] = "Inserido com sucesso!";
			$retorno["status"] = true;
			$codigo = $bi_log_acessoDAO->salvar($bi_log_acesso);
		}
		catch (Exception  $e)
		{
			$retorno["mensagem"] = $e->getMessage();
			$retorno["status"] = false;
		}
	}
	echo json_encode($retorno);
}
elseif (isset($_GET["mod"]) && $_GET["mod"] == "excluir")
{
	try
	{
		$bi_log_acesso = $bi_log_acessoDAO->buscarBi_log_acesso($_GET["codigo"]);
		$bi_log_acessoDAO->excluir($bi_log_acesso);
		$retorno["mensagem"] = utf8_decode("Excluido com sucesso!");
		$retorno["status"] = true;
	}
	catch (Exception  $e)
	{
		$retorno["mensagem"] = $e->getMessage();
		$retorno["status"] = false;
	}
	echo json_encode($retorno);
}
elseif (isset($_GET["mod"]) && $_GET["mod"] == "listar")
{
	if (isset($_GET["usuario"]) and $_GET["usuario"] != "")
	{
		$campo_buscar = "&usuario=".$_GET["usuario"]; 
	}
	if (isset($_GET["analise"]) and $_GET["analise"] != "")
	{
		$campo_buscar = "&analise=".$_GET["analise"]; 
	}
	if (isset($_GET["pagina"]) and $_GET["pagina"] != "")
	{
		$campo_buscar = "&pagina=".$_GET["pagina"]; 
	}
	$listaBi_log_acesso = $bi_log_acessoDAO->listarTodosRegistros();
	include_once($config->diretorio_raiz()."/src/view/bi_log_acesso/Listar_todos_registros.php");
}
elseif (isset($_GET["mod"]) && $_GET["mod"] == "filtro")
{
	if ( (isset($_GET["codigo"]) and $_GET["codigo"] != "")  )
	{
		$bi_log_acesso = $bi_log_acessoDAO->buscarBi_log_acesso($_GET["codigo"]);
	}else{
		$bi_log_acesso = new Bi_log_acesso();
		$bi_log_acesso->setUsuario(new Bi_usuario());
		$bi_log_acesso->setAnalise(new Bi_analise());
		$bi_log_acesso->setPagina(new Bi_pagina());
	}
	$listaUsuario = $bi_usuarioDAO->listarTodosRegistros(); 
	$listaAnalise = $bi_analiseDAO->listarTodosRegistros(); 
	$listaPagina = $bi_paginaDAO->listarTodosRegistros(); 
	if (isset($_GET["usuario"]) and $_GET["usuario"] != "")
	{
		$bi_log_acesso->setUsuario($bi_usuarioDAO->buscarBi_usuario($_GET["usuario"]));
		$campo_buscar = "&usuario=".$_GET["usuario"]; 
	}
	if (isset($_GET["analise"]) and $_GET["analise"] != "")
	{
		$bi_log_acesso->setAnalise($bi_analiseDAO->buscarBi_analise($_GET["analise"]));
		$campo_buscar = "&analise=".$_GET["analise"]; 
	}
	if (isset($_GET["pagina"]) and $_GET["pagina"] != "")
	{
		$bi_log_acesso->setPagina($bi_paginaDAO->buscarBi_pagina($_GET["pagina"]));
		$campo_buscar = "&pagina=".$_GET["pagina"]; 
	}
	include_once($config->diretorio_raiz()."/src/view/bi_log_acesso/Filtro_lista_registros.php");
}
elseif (isset($_GET["mod"]) && $_GET["mod"] == "busca_por_campo_filtro")
{
	$entrouEmAlgumFiltro = false;
 	$where = " where 1=1";
	if(isset($_GET['codigo']) and $_GET["codigo"] != "" )
	{
		$where .= " and UPPER(codigo) like '%".strtoupper($_GET['codigo'])."%'";
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&codigo=".$_GET["codigo"]; 
	}
	if(isset($_POST['codigo']) and $_POST["codigo"] != "" )
	{
		$where .= " and UPPER(codigo) like '%".strtoupper($_POST['codigo'])."%'";
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&codigo=".$_POST["codigo"]; 
	}
	if(isset($_GET['usuario']) and $_GET['usuario'] != "")
	{
		$where .= " and usuario = ". $_GET['usuario'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&usuario=".$_GET["usuario"]; 
	}
	if(isset($_POST['usuario']) and $_POST['usuario'] != "")
	{
		$where .= " and usuario = ". $_POST['usuario'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&usuario=".$_POST["usuario"]; 
	}
	if(isset($_GET['analise']) and $_GET['analise'] != "")
	{
		$where .= " and analise = ". $_GET['analise'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&analise=".$_GET["analise"]; 
	}
	if(isset($_POST['analise']) and $_POST['analise'] != "")
	{
		$where .= " and analise = ". $_POST['analise'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&analise=".$_POST["analise"]; 
	}
	if(isset($_GET['pagina']) and $_GET['pagina'] != "")
	{
		$where .= " and pagina = ". $_GET['pagina'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&pagina=".$_GET["pagina"]; 
	}
	if(isset($_POST['pagina']) and $_POST['pagina'] != "")
	{
		$where .= " and pagina = ". $_POST['pagina'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&pagina=".$_POST["pagina"]; 
	}
	if(isset($_GET['data_acessoIni']) and $_GET['data_acessoIni'] != "" and $_GET['data_acessoFim'] != "")
	{
		$dateIni = DateTime::createFromFormat('d/m/Y H:i', $_GET['data_acessoIni']);
		$dateFim = DateTime::createFromFormat('d/m/Y H:i', $_GET['data_acessoFim']);
		$where .= " and data_acesso >= '".$dateIni->format('Y-m-d H:i').''."'";
		$where .= " and data_acesso <= '".$dateFim->format('Y-m-d H:i').''."'";
		$entrouEmAlgumFiltro = true;
	}
	if(isset($_POST['data_acessoIni']) and $_POST['data_acessoIni'] != "" and $_POST['data_acessoFim'] != "")
	{
		$dateIni = DateTime::createFromFormat('d/m/Y H:i', $_POST['data_acessoIni']);
		$dateFim = DateTime::createFromFormat('d/m/Y H:i', $_POST['data_acessoFim']);
		$where .= " and data_acesso >= '".$dateIni->format('Y-m-d H:i').''."'";
		$where .= " and data_acesso <= '".$dateFim->format('Y-m-d H:i').''."'";
		$entrouEmAlgumFiltro = true;
	}
	$listaBi_log_acesso = $bi_log_acessoDAO->buscarFiltro($where);
	include_once($config->diretorio_raiz()."/src/view/bi_log_acesso/Listar_todos_registros.php");
}
